stages:
  - static-analysis
  - test

default:
  image: python:3.8
  before_script:
    - python3 -m pip install -U pip setuptools

lint:
  stage: static-analysis
  script:
    - python3 -m pip install pre-commit
    - pre-commit install
    - pre-commit run --all-files --show-diff-on-failure

typecheck:
  stage: static-analysis
  script:
    - python3 -m pip install poetry
    - poetry install
    - poetry run mypy knowledge_integrity tests

test:
  stage: test
  image: $IMAGE
  script:
    - python3 -m pip install poetry
    - poetry install --all-extras
    - poetry run pytest -vv
  parallel:
    matrix:
      - IMAGE: ["python:3.8", "python:3.9", "python:3.10"]
